      program cmpx_2_unform
      complex z(3000,1500)
      character type*1,tide*2,insfn*64,str*64
      logical qop21,qop22
      data insfn/'mzfu.ins'/
      iut=4
      iuterm=10
      call getarg (1,str)
      if (str(1:1).ne.' ') insfn=str
      call open_term (iuterm)
      call open_ins (iut,insfn)
      if (iut.eq.5) then
         call openfs ('21 P CMPX formatted input')
         call openfs ('31 P CMPX unformatted output')
      else
         call openf  (iut) 
      endif
      inquire (unit=21,opened=qop21)
      inquire (unit=22,opened=qop22)
      if (qop21) then
         call getsiz_f (21,m,n)
         type='.'
         tide='..'
         call getzm_f  (21,z,m,n,type,tide)
         call getver_f (nver)
      elseif (qop22) then
         call size_indxd_zm (22,m,n)
         call read_indxd_zm (22,z,m,n)
         type='M'
         tide='..'
         nver=1
         if (iut.eq.5) 
     &      print *,'Specify grid type,tide and version number:'
         read (iut,*,end=9,err=9) type,tide,nver
 9       continue
      endif
      call setver   (nver)
      call outzm    (31,z,m,n,type,tide)
      stop
      end

      subroutine read_indxd_zm (iun,z,m,n)
      complex z(m,n),zval
      character type*1, tide*2
      save

      rewind (iun)
      
 1    read (iun,*,end=99) i,j,zval
      indx=i-i0+1
      jndx=j-j0+1
      z(indx,jndx)=zval
      goto 1
 99   return

      entry size_indxd_zm (iun,m,n)
      i0=999999
      j0=999999
      ie=-999999
      je=-999999

 11   read (iun,*,end=19) i,j
      i0=min0(i,i0)
      j0=min0(j,j0)
      ie=max0(i,ie)
      je=max0(j,je)
      goto 11
      
 19   m=ie-i0+1
      n=je-j0+1
      print '(a,2i7)',' <SizIZm>>> Size ',m,n
      return
      end


