      SUBROUTINE IOMSG (CPGM,TYPE,VARTYP,IUN,TAG,NVER)
C I/O utility * General completion message
      CHARACTER TYPE*1,VARTYP*(*),TAG*2,NAME*64,BUFF*132,CPGM*6
     &,         MSG*13, TYP*32
      DIMENSION MSG(2)
      LOGICAL   QMSG(0:99),QQ,QENT
      SAVE      QMSG
      DATA MSG/' array, grid ',' common, var.'/,QMSG/100*.TRUE./

      QENT=.false.
      goto 101

      ENTRY AIOMSG (CPGM,TYPE,M,N,VARTYP,IUN,TAG,NVER)
      QENT=.true.
      
 101  IF (IUN.LT.0.OR.IUN.GT.99) RETURN
      IF (.NOT.QMSG(IUN)) RETURN

      IF (QENT) THEN
         TYP=TYPE
         WRITE (TYP(3:),'(I6,1Hx,I6)') M,N
         CALL DELETE_IN_STRING (TYP,' ',3,0)
      ELSE
         TYP=TYPE
      ENDIF
      LTY=INDEX_L_NONBLANK(TYP)
     
      IMSG=INDEX(VARTYP,'/')+1
      WRITE (BUFF,'(132(1H ))')
      CALL GET_FILE_NAME (IUN,NAME)
      I=INDEX_L_NONBLANK (NAME)
      WRITE (BUFF,1001)
     &  CPGM,VARTYP,MSG(IMSG),TYP(:LTY),IUN,NAME(:I)//' $'
1001  FORMAT (' <',A6,'>>> ',2A,A,', f.unit ', I2,': ',A)
      IF (TAG.NE.'//') THEN
         I=INDEX(BUFF,'$')
         WRITE (BUFF(I:),1002) TAG//' $'
      ENDIF
1002  FORMAT ('-->',A)
      IF (NVER.GT.0
     &  .OR.(VARTYP(1:4).EQ.'CMPX'.AND.NVER.GT.-1)
     &  .OR.(CPGM.EQ.'OUTZM-')) THEN
         I=INDEX(BUFF,'$')
         WRITE (BUFF(I:),1003) NVER
      ENDIF
1003  FORMAT (' #',I6,' $')
      I=INDEX(BUFF,'$')-1
      PRINT '(A)', BUFF(:I)
      RETURN

      ENTRY IOMSG_FOR_UNIT (IUN,QQ)
      QMSG(IUN)=QQ
      RETURN
      END

      SUBROUTINE RPARSE (CPGM,TYPE,TYPF,REQVAR,VARTYP,*,*)
C Read utility * Check grid type and data type
C
C This routine is called by some GETxxx-routines. Nothing for the user
C to consider unless own I/O-routines are coded.
C
C CPGM    - char*6 - Name of calling program
C TYPE    - char*1 - Grid type requested
C TYPF    - char*1 - Grid type found in header record
C REQVAR  - char*4 - Data type requested
C VARTYP  - char*4 - Data type found in header record
C *1      - &label - Branch case wrong grid type
C *2      - &label - Branch case wrong data type
C
      CHARACTER CPGM*6,TYPE*1,TYPF*1,VARTYP*4,REQVAR*(*)
      LOGICAL QUCSS
      COMMON /CGETXX/ ERRNO
      INTEGER ERRNO
      DATA ERRNO/0/

      IF (INDEX(' .?',TYPE).LE.0.AND.TYPF.NE.TYPE) GOTO 91
      IF (.NOT.QUCSS(REQVAR,VARTYP,'|',ID1,ID2,ID3)) GOTO 92
      ERRNO=0
      RETURN
91    PRINT 1001, CPGM,TYPE,TYPF
1001  FORMAT (' <',A6,'>E> Requested grid "',A1
     &,'", encountered "',A1,'"')
      ERRNO=1
      RETURN 1
92    PRINT 1002, CPGM,REQVAR,VARTYP
1002  FORMAT (' <',A6,'>E> Requested data ',A4
     &,' Encountered ',A4)
      ERRNO=2
      RETURN 2
      END

      INTEGER FUNCTION GETXXX_ERRNO ()
      COMMON /CGETXX/ ERRNO
      INTEGER ERRNO
      GETXXX_ERRNO=ERRNO
      RETURN
      END


C:Provides  subroutine iomsg F=iomsg.f
C:Provides  subroutine rparse F=iomsg.f
C:Provides  integer function getxxx_errno F=iomsg.f
C:Provides  entry aiomsg F=iomsg.f
C:Provides  entry iomsg_for_unit F=iomsg.f
