      SUBROUTINE GETAST_f (IUN,M,N,TYP,VTYP)
C Read utility * Get Array Size and Types
      CHARACTER TYP*1,FTYP*1,VTYP*4,FVTYP*4,buff*32
      read (iun,buff,end=99)
      if (index(buff,'CMPX').gt.0) then
         READ (buff,1003) K,L,FTYP,FVTYP
      else
         READ (buff,1002) K,L,FTYP,FVTYP
      endif
      BACKSPACE (IUN)
      M=K
      N=L
      TYP=FTYP
      VTYP=FVTYP
      PRINT '(A,2I8,5A,I2)',' <GetasF>>> ',M,N,' '
     &,      VTYP,' data on grid "',TYP,'" on file unit ',IUN
      RETURN
99    PRINT '(A,I2)',' <GetasF>E> End of file, log.unit ',IUN
      TYP='e'
      RETURN
1002  FORMAT (2I5,1X,A1,1X,A4,1X,A2,I6)
 1003 FORMAT (2I10,1X,A1,1X,A4,1X,A2,I6)
      END

      SUBROUTINE GETIM_f (IUN,IM,M,N,TYPE)
C Read utility * Flag array
      CHARACTER TYPE*1,TYPF*1,VARTYP*4
      INTEGER IM(M,N)
      READ (IUN,1002,ERR=9,END=99) K,L,TYPF,VARTYP
      CALL RPARSE ('GetimF',TYPE,TYPF,'FLAG',VARTYP,*91,*91)
      TYPE=TYPF
      DO 101 J=N,1,-1
101   READ (IUN,1001) (IM(I,J),I=1,M)
      CALL IOMSG ('GetimF',TYPE,VARTYP,IUN,'//',-1)
91    RETURN
C
9     PRINT '(A,I2)',' <GetimF>E> ERR unit ',IUN
      RETURN
99    PRINT '(A,I2)',' <GetimF>E> EOF unit ',IUN
      RETURN
1001  FORMAT (20I6)
1002  FORMAT (2I5,1X,A1,1X,A4,1X,A2,I6)
      END

      SUBROUTINE GETRM_f (IUN,R,M,N,TYPE)
C Read utility * Real array
      CHARACTER TYPE*1,TYPF*1,VARTYP*4,FMTD*64,FMTR*64
      COMMON /CODFMT/ FMTD,FMTR
      REAL R(M,N)
      READ (IUN,1002,ERR=9,END=99) K,L,TYPF,VARTYP
      CALL RPARSE ('GETRM-',TYPE,TYPF,'REAL|DBLE|CMPX',VARTYP,*91,*91)
      TYPE=TYPF
      DO 101 J=N,1,-1
101   READ (IUN,FMTR) (R(I,J),I=1,M)
      CALL IOMSG ('GetrmF',TYPE,VARTYP,IUN,'//',-1)
91    RETURN
C
9     PRINT '(A,I2)',' <GetrmF>E> ERR unit ',IUN
      RETURN
99    PRINT '(A,I2)',' <GetrmF>E> EOF unit ',IUN
      RETURN
1002  FORMAT (2I5,1X,A1,1X,A4,1X,A2,I6)
      END

      SUBROUTINE GETDM_f (IUN,R,M,N,TYPE)
C Read utility * Real array
      CHARACTER TYPE*1,TYPF*1,VARTYP*4,FMTD*64,FMTR*64
      COMMON /CODFMT/ FMTD,FMTR
      REAL*8 R(M,N)
      READ (IUN,1002,ERR=9,END=99) K,L,TYPF,VARTYP
      CALL RPARSE ('GETRM-',TYPE,TYPF,'REAL|DBLE|CMPX',VARTYP,*91,*91)
      TYPE=TYPF
      DO 101 J=N,1,-1
101   READ (IUN,FMTR) (R(I,J),I=1,M)
      CALL IOMSG ('GetdmF',TYPE,VARTYP,IUN,'//',-1)
91    RETURN
C
9     PRINT '(A,I2)',' <GetdmF>E> ERR unit ',IUN
      RETURN
99    PRINT '(A,I2)',' <GetdmF>E> EOF unit ',IUN
      RETURN
1002  FORMAT (2I5,1X,A1,1X,A4,1X,A2,I6)
      END

      SUBROUTINE GETZM_f (IUN,R,M,N,TYPE,TAG)
C Read utility * Complex array
C
C Return codes in TAG in case of errors:
C EF - end of file                     EC - data not complex
C ET - wrong matrix type (TYPE)        ES - wrong tide symbol (TAG)
C ER - error when reading header       EV - wrong version n. (LGETZM)
C
C For your safety, restore TAG before each subsequent call.
C
C
C ENTRY LGETZM (...,RQVER) - for locating a data set:
C
C RQVER - integer - requested version number. A data set stored after
C         CALL SETVER (J) on a file which contains a set of similar
C         data sets is retrieved: specify RQVER = J. If the version
C         requested is not found, the last set is taken, and TAG is
C         set 'EV' on return.
C
      CHARACTER EFL*1,TYPE*1,TYPF*1,VARTYP*4,TAG*2,TTAG*2,CPGM*6
      LOGICAL QL
      INTEGER RQVER
      COMPLEX R(M,N)
      SAVE NVERS

      QL=.FALSE.
      CPGM='GetzmF'
      NVERS=-1
      NDT=0
      GOTO 102

      ENTRY LGETZM_f (IUN,R,M,N,TYPE,TAG,RQVER)
C Read utility * Complex array with version number
      QL=.TRUE.
      CPGM='Lgetzm'
      NDT=0
      NVERS=RQVER
102   READ (IUN,1002,ERR=9,END=99) K,L,TYPF,VARTYP,TTAG,NVER
      CALL RPARSE (CPGM,TYPE,TYPF,'CMPX|REAL|DBLE',VARTYP,*91,*92)
      TYPE=TYPF
      DO 101 J=N,1,-1
101   READ (IUN,1001,END=98) (R(I,J),I=1,M)
      NVERS=NVER
C
C Check tide and version number:
      NDT=NDT+1
      IF (.NOT.QL.AND.INDEX('  ..??**',TAG).LE.0.AND.TAG.NE.TTAG)
     &   GOTO 93
      IF (QL.AND.NVER.NE.NVERS) GOTO 102
      IF (INDEX('  ..??**',TAG).le.0.AND.TAG.NE.TTAG)
     &   GOTO 102
      TAG=TTAG
89    CALL IOMSG (CPGM,TYPF,VARTYP,IUN,TTAG,NVER)
90    TYPE=TYPF
      RETURN
C
9     PRINT '(A)',' <'//CPGM//'>E> Cannot recognize data'
      TAG='ER'
      RETURN
91    TAG='ET'
      RETURN
92    TAG='EC'
      RETURN
93    PRINT '(2(A,A2))',' <'//CPGM//'>E> Requested tag ',TAG
     &, ', encountered ',TTAG
      TAG=TTAG
      GOTO 89
99    EFL='W'
      IF (NDT.EQ.0) EFL='E'
      PRINT '(A,I2,A,I5)'
     &,     ' <'//CPGM//'>'//EFL//'> End of file, log.unit '
     &,      IUN,'. Sections read: ',NDT
      IF (QL.AND.NDT.GT.0)
     &    CALL IOMSG ('  "   ',TYPE,VARTYP,IUN,TAG,NVER)
      TAG='EF'
      IF (QL) RQVER=NVER
      IF (QL) TAG='EV'
      GOTO 90
98    PRINT '(A,I4,A)',' <'//CPGM//'>T> Data truncated after ',N-J
     &,     ' operations.'
      STOP

      ENTRY GETVER_f (IVER)
C Read utility * Get version number, multi-CMPX-array recently read.
      IF (NVERS.EQ.-1) PRINT '(A)'
     &, ' <GetveF>W> Bad version number due to recent read problem.'
      IVER=NVERS
      RETURN
1001  FORMAT (10E12.6)
1002  FORMAT (2I10,1X,A1,1X,A4,1X,A2,1X,I10)
      END

      SUBROUTINE GETLMI_f (IUN,IM,M,N,TYPE,LWORK)
C Read utility * Flag array, convert log*1 -> integer
C
C LWORK(M) - logical*1 - work (buffer)
C
      CHARACTER TYPE*1,TYPF*1,VARTYP*4
      INTEGER IM(M,N)
      CHARACTER*1 LWORK(M)
      READ (IUN,1002,ERR=9,END=99) K,L,TYPF,VARTYP
      CALL RPARSE ('GETLMI',TYPE,TYPF,'LOG1',VARTYP,*91,*91)
      TYPE=TYPF
      kount=0
      DO 101 J=N,1,-1
      READ (IUN,1001) LWORK
      DO 101 I=1,M
      IF (LWORK(I).eq.'T') THEN
         IM(I,J)=1
         kount=kount+1
      ELSE
         IM(I,J)=0
      ENDIF
101   CONTINUE
      CALL IOMSG ('Getlmi',TYPE,VARTYP,IUN,'//',-1)
      PRINT '(a,2i5,a,i10)'
     &,     ' <Getlmi>>> {F,T}(i,j) -> {0,1}(i,j), size: ',M,N
     &,     ' formatted, count(flg=1):',kount
91    RETURN
9     PRINT '(A,I2)',' <Getlmi>E> ERR unit ',IUN
      RETURN
99    PRINT '(A,I2)',' <Getlmi>E> EOF unit ',IUN
      RETURN
1001  FORMAT (120a1)
1002  FORMAT (2I5,1X,A1,1X,A4,1X,A2,I6)
      END

C
      SUBROUTINE GETSIZ_f (IUN,M,N)
C Read utility * Get size of array + Backspace
      READ (IUN,*,END=99) K,L
      M=K
      N=L
      BACKSPACE (IUN)
      PRINT '(A,2I8,A,I2)',' <GetsiF>>> ',M,N,' array on file unit ',IUN
      RETURN
99    PRINT '(A,I2)',' <GetsiF>E> End of file, log.unit ',IUN
      RETURN
1002  FORMAT (2I5,1X,A1,1X,A4,1X,A2,I6)
      END
C:Provides  subroutine getim_f F=oteur1f.f
C:Provides  subroutine getrm_f F=oteur1f.f
C:Provides  subroutine getdm_f F=oteur1f.f
C:Provides  subroutine getzm_f F=oteur1f.f
C:Provides  subroutine getlmi_f F=oteur1f.f
C:Provides  subroutine getsiz_f F=oteur1f.f
C:Provides  entry lgetzm_f F=oteur1f.f
C:Provides  entry getver_f F=oteur1f.f
