      SUBROUTINE OUTIM (IUN,IM,M,N,TYPE)
C Write utility * Flag array
      CHARACTER*1 TYPE
      INTEGER IM(M,N)
      WRITE (IUN) M,N,TYPE,'FLAG'
      DO 101 J=N,1,-1
101   WRITE (IUN) (IM(I,J),I=1,M)
      CALL AIOMSG ('OUTIM-',TYPE,M,N,'FLAG',IUN,'//',-1)
      RETURN
      END

      SUBROUTINE OUTRM (IUN,R,M,N,TYPE)
C Write utility * Real array
      REAL R(M,N)
      CHARACTER*1 TYPE
      WRITE (IUN) M,N,TYPE,'REAL'
      DO 101 J=N,1,-1
101   WRITE (IUN) (R(I,J),I=1,M)
      CALL AIOMSG ('OUTRM-',TYPE,M,N,'REAL',IUN,'//',-1)
      RETURN
      END

      SUBROUTINE OUTDM (IUN,R,M,N,TYPE)
C Write utility * Real*8 array
      REAL*8 R(M,N)
      CHARACTER*1 TYPE
      WRITE (IUN) M,N,TYPE,'DBLE'
      DO 101 J=N,1,-1
101   WRITE (IUN) (R(I,J),I=1,M)
      CALL AIOMSG ('OUTDM-',TYPE,M,N,'DBLE',IUN,'//',-1)
      RETURN
      END

      SUBROUTINE OUTZM (IUN,R,M,N,TYPE,TAG)
C Write utility * Complex array
C
C Denoting a data version number on the file:
C (alt 1) Using COMMON /CVER/ I      in the calling programme
C (alt 2) Calling SETVER(I)          before OUTZM/OUTZMN is called.
C I is integer*4.
C If a couple of matrices are stored on the same file, use
C CALL LGETZM (....,J) in order to retrieve version J.
C
      COMPLEX R(M,N)
      CHARACTER TYPE*1, TAG*2
      COMMON /CVER/ NVER

      SU=1.
      GOTO 1
      ENTRY OUTZMN (IUN,R,S,M,N,TYPE,TAG)
C Write utility * unscaling a complex scaled array
      IF (ABS(S).LT.1.E-30) THEN
         PRINT '(A)',' <OUTZMN>E> Scaling by zero. No output.'
         RETURN
      ENDIF
      SU=S
1     WRITE (IUN) M,N,TYPE,'CMPX',TAG,NVER
      DO 101 J=N,1,-1
101   WRITE (IUN) (R(I,J)/SU,I=1,M)
      CALL AIOMSG ('OUTZM-',TYPE,M,N,'CMPX',IUN,TAG,NVER)
      RETURN
      END

      SUBROUTINE OUTIML (IUN,FLZ,M,N,TYP,LWORK)
C Write utility * Flags convert LOG*1 .false. where 0
      LOGICAL*1 LWORK(M)
      INTEGER FLZ(M,N)
      CHARACTER*1 TYP
      WRITE (IUN) M,N,TYP,'LOG1'
      DO 101 J=N,1,-1
      DO 102 I=1,M
102   LWORK(I)=FLZ(I,J).NE.0
101   WRITE (IUN) LWORK
      CALL AIOMSG ('OUTIML',TYP,M,N,'LOG1',IUN,'//',-1)
C      PRINT '(A,2I5)',' <OUTIML>>> L(i,j)=I(i,j).ne.0'
      RETURN
      END

C:Provides  subroutine outim F=oteuw1.f
C:Provides  subroutine outrm F=oteuw1.f
C:Provides  subroutine outdm F=oteuw1.f
C:Provides  subroutine outzm F=oteuw1.f
C:Provides  subroutine outiml F=oteuw1.f
C:Provides  entry outzmn F=oteuw1.f
