      SUBROUTINE OUTIM_f (IUN,IM,M,N,TYPE)
C Write utility * Flag array
      CHARACTER*1 TYPE
      INTEGER IM(M,N)
      WRITE (IUN,2101) M,N,TYPE,'FLAG'
      DO 101 J=N,1,-1
101   WRITE (IUN,2102) (IM(I,J),I=1,M)
      CALL IOMSG ('OutimF',TYPE,'FLAG',IUN,'//',-1)
      RETURN
2101  format (2i5,1x,a1,1x,a4,1x,a2,1x,i10)
2102  format (20i6,:)
      END

      SUBROUTINE OUTLM_f (IUN,IM,M,N,TYPE)
C Write utility * Log1 Flag array
      CHARACTER*1 TYPE
      LOGICAL*1   IM(M,N)
      WRITE (IUN,2101) M,N,TYPE,'LOG1'
      DO 101 J=N,1,-1
101   WRITE (IUN,2102) (IM(I,J),I=1,M)
      CALL IOMSG ('OutlmF',TYPE,'LOG1',IUN,'//',-1)
      RETURN
2101  format (2i5,1x,a1,1x,a4,1x,a2,1x,i10)
2102  format (120L1,:)
      END

      SUBROUTINE GETLM (IUN,IM,M,N,TYPE)
C Read utility * Log1 Flag array
      CHARACTER TYPE*1,TYPF*1,VARTYP*4,NAME*32
      LOGICAL*1 IM(M,N)
      READ (IUN,ERR=9,END=99) K,L,TYPF,VARTYP
      CALL RPARSE ('GETLM-',TYPE,TYPF,'LOG1',VARTYP,*91,*91)
      TYPE=TYPF
      DO 101 J=N,1,-1
101   READ (IUN) (IM(I,J),I=1,M)
      CALL IOMSG ('GETLM-',TYPE,VARTYP,IUN,'//',-1)
91    RETURN
C
9     PRINT '(A,I2)',' <GETLM->E> ERR unit ',IUN
      RETURN
99    PRINT '(A,I2)',' <GETLM->E> EOF unit ',IUN
      RETURN
      END

      SUBROUTINE GETLM_F (IUN,IM,M,N,TYPE)
C Read utility * Log1 Flag array
      CHARACTER TYPE*1,TYPF*1,VARTYP*4
      LOGICAL*1 IM(M,N)
      READ (IUN,2101,ERR=9,END=99) K,L,TYPF,VARTYP
      CALL RPARSE ('GetlmF',TYPE,TYPF,'LOG1',VARTYP,*91,*91)
      TYPE=TYPF
      DO 101 J=N,1,-1
101   READ (IUN,2103) (IM(I,J),I=1,M)
      CALL IOMSG ('GetlmF',TYPE,VARTYP,IUN,'//',-1)
91    RETURN
C
9     PRINT '(A,I2)',' <GetlmF>E> ERR unit ',IUN
      RETURN
99    PRINT '(A,I2)',' <GetlmF>E> EOF unit ',IUN
      RETURN
2101  format (2i5,1x,a1,1x,a4,1x,a2,1x,i10)
2103  format (120l1:)
      END
      
      SUBROUTINE OUTRM_f (IUN,R,M,N,TYPE)
C Write utility * Real array
      REAL R(M,N)
      CHARACTER TYPE*1, FMTD*64, FMTR*64, STR*(*)

      COMMON /CODFMT/ FMTD,FMTR
      DATA FMTD/'(1p,10d12.4,:)'/,FMTR/'(1p,10e12.4,:)'/

      WRITE (IUN,2101) M,N,TYPE,'REAL'
      DO 101 J=N,1,-1
101   WRITE (IUN,FMTR) (R(I,J),I=1,M)
      CALL IOMSG ('OutrmF',TYPE,'REAL',IUN,'//',-1)
      RETURN
2101  format (2i5,1x,a1,1x,a4,1x,a2,1x,i10)
      ENTRY OUTRM_fmt (STR)
      ENTRY GETRM_fmt (STR)
      ENTRY OUTZM_fmt (STR)
      ENTRY GETZM_fmt (STR)
      FMTR=STR
      RETURN
      END

      SUBROUTINE OUTDM_f (IUN,R,M,N,TYPE)
C Write utility * Real array
      REAL*8 R(M,N)
      CHARACTER TYPE*1, FMTD*64, FMTR*64, STR*(*)
      COMMON /CODFMT/ FMTD,FMTR
      WRITE (IUN,2101) M,N,TYPE,'DBLE'
      DO 101 J=N,1,-1
101   WRITE (IUN,FMTD) (R(I,J),I=1,M)
      CALL IOMSG ('OutdmF',TYPE,'DBLE',IUN,'//',-1)
      RETURN
2101  format (2i5,1x,a1,1x,a4,1x,a2,1x,i10)
      ENTRY OUTDM_fmt (STR)
      ENTRY GETDM_fmt (STR)
      FMTD=STR
      RETURN
      END

      SUBROUTINE OUTLM (IUN,R,M,N,TYPE)
C Write utility * log*1 array
      LOGICAL*1 R(M,N)
      CHARACTER*1 TYPE
      WRITE (IUN) M,N,TYPE,'LOG1'
      DO 101 J=N,1,-1
101   WRITE (IUN) (R(I,J),I=1,M)
      CALL IOMSG ('OUTLM-',TYPE,'LOG1',IUN,'//',-1)
      RETURN
      END

      SUBROUTINE OUTZM_f (IUN,R,M,N,TYPE,TAG)
C Write utility * Complex array
C
C Denoting a data version number on the file:
C (alt 1) Using COMMON /CVER/ I      in the calling programme
C (alt 2) Calling SETVER(I)          before OUTZM/OUTZMN is called.
C I is integer*4.
C If a couple of matrices are stored on the same file, use
C CALL LGETZM (....,J) in order to retrieve version J.
C
      COMPLEX R(M,N)
      CHARACTER TYPE*1, TAG*2, FMTD*64, FMTR*64
      COMMON /CVER/ NVER
      COMMON /CODFMT/ FMTD,FMTR
      SAVE /CVER/
      SU=1.
      GOTO 1
      ENTRY OUTZMN_f (IUN,R,S,M,N,TYPE,TAG)
C Write utility * unscaling a complex scaled array
      IF (ABS(S).LT.1.E-30) THEN
         PRINT '(A)',' <OutzNF>E> Scaling by zero. No output.'
         RETURN
      ENDIF
      SU=S
1     WRITE (IUN,2101) M,N,TYPE,'CMPX',TAG,NVER
      DO 101 J=N,1,-1
101   WRITE (IUN,FMTR) (R(I,J)/SU,I=1,M)
      CALL IOMSG ('OutzmF',TYPE,'CMPX',IUN,TAG,NVER)
      RETURN
2101  format (2i10,1x,a1,1x,a4,1x,a2,1x,i10)
      END

      subroutine outiml_f (iun,flz,m,n,typ,lwork)
C Write utility * Flags convert LOG*1 .false. where 0
      logical*1 lwork(m)
      integer flz(m,n)
      character*1 typ
      write (iun,2101) m,n,typ,'LOG1'
      do 101 j=n,1,-1
      do 102 i=1,m
102   lwork(i)=flz(i,j).ne.0
101   write (iun,2104) lwork
      CALL IOMSG ('OutiLF',TYP,'LOG1',IUN,'//',-1)
      print '(A,2I5)',' <OutiLF>>> L(i,j)=I(i,j).ne.0, size: ',m,n
      return
2101  format (2i5,1x,a1,1x,a4,1x,a2,1x,i10)
2104  format (120l1,:)
      end

C:Provides  subroutine outim_f F=oteuw1f.f
C:Provides  subroutine outlm_f F=oteuw1f.f
C:Provides  subroutine getlm F=oteuw1f.f
C:Provides  subroutine getlm_f F=oteuw1f.f
C:Provides  subroutine outrm_f F=oteuw1f.f
C:Provides  subroutine outdm_f F=oteuw1f.f
C:Provides  subroutine outlm F=oteuw1f.f
C:Provides  subroutine outzm_f F=oteuw1f.f
C:Provides  subroutine outiml_f F=oteuw1f.f
C:Provides  entry outrm_fmt F=oteuw1f.f
C:Provides  entry getrm_fmt F=oteuw1f.f
C:Provides  entry outzm_fmt F=oteuw1f.f
C:Provides  entry getzm_fmt F=oteuw1f.f
C:Provides  entry outdm_fmt F=oteuw1f.f
C:Provides  entry getdm_fmt F=oteuw1f.f
C:Provides  entry outzmn_f F=oteuw1f.f
